;  Copyright (C) 2006 Red Hat Inc.
;
;  This file is part of GAS, the GNU Assembler.
;
;  GAS is free software; you can redistribute it and/or modify
;  it under the terms of the GNU General Public License as published by
;  the Free Software Foundation; either version 2, or (at your option)
;  any later version.
;
;  GAS is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public License
;  along with GAS; see the file COPYING.  If not, write to
;  the Free Software Foundation, 59 Temple Place - Suite 330,
;  Boston, MA 02111-1307, USA.  */


macro	sdsp8	{-128;-1;0;1;127;0x7f}
macro	udsp8	{0;1;255;0xff}
macro	sdsp16	{-32768;-1;0;1;32767;0x7fff;sym}
macro	udsp16	{0;1;65535;0xffff;sym}
macro	udsp20	{0;1;1048575;0xfffff;sym}
macro	abs16	{0;1;65535;0xffff;sym}
macro	abs20	{0;1;1048575;0xfffff;sym}

macro	addrs	{{;{udsp8};{udsp16}}[a{0;1}];{{udsp8};{udsp16}}[sb];{sdsp8}[fb];{abs16}}
macro	fb8	{sdsp8}[fb]
macro	sb8	{udsp8}[sb]

macro	uimm3	#{0;7}
macro	simm4	#{-8;0;7}
macro	simm4n	#{-7;0;8}
macro	nimm4	#{-8;-1;1;8}
macro	uimm6	#{0;63}
macro	uimm8	#{udsp8}
macro	simm8	#{sdsp8}
macro	dimm8	#{0;1;99}
macro	imm8	#{-127;-1;{udsp8}}
macro	uimm16	#{udsp16}
macro	simm16	#{sdsp16}
macro	dimm16	#{0;1;9999}
macro	imm16	#{-32768;-1;{udsp16}}

macro	sdb	{r0l;r0h;r1l;r1h;a0;a1;{addrs}}
macro	sdw	{r0;r1;r2;r3;a0;a1;{addrs}}
macro	sda	{r2r0;r3r1;a1a0;{addrs}}
macro	dst2b	{{udsp8}[sb];{sdsp8}[fb];{abs16}}
macro	dst3b	{r0h;r0l;{udsp8}[sb];{sdsp8}[fb];{abs16}}
macro	cr	{intbl;intbh;flg;isp;sp;sb;fb}

macro	sdsp5	{-16;-1;0;1;15;0xf}
macro	udsp5	{0;1;31;0x1f}
macro	udsp13	{0;1;8191;0x1fff}
macro	bit3	{0;7}
macro	bit4	{0;15}

macro	bsrc	{{{bit4},{r0;r1;r2;r3;a0;a1}};{;{udsp8};{udsp16}}[a{0;1}];{bit3},{sdsp5}[fb];{bit3},{udsp5}[sb];{bit3},{udsp13}[sb];{bit3},{udsp13}}

macro	laddrs	{{;{udsp8};{udsp20}}[a{0;1}];{sdsp8}[fb];{abs16}}
macro	labelw	{r0;r1;r2;r3;a0;a1;{laddrs}}
macro	labela	{r2r0;r3r1;a1a0;{laddrs}}

macro	cond	{geu;c;gtu;eq;z;n;le;o;ge;ltu;nc;leu;ne;nz;pz;gt;no;lt}
macro	label8	{.-126;.+128;foo}
macro	label16	{.+2;foo}
macro	label20	{.+2;0x1000;foo}

macro	g	{;:g}

	abs.b		{sdb}
	abs.w		{sdw}

	adc.b		{imm8},{sdb}
	adc.w		{imm16},{sdw}
	adc.b		{sdb},{sdb}
	adc.w		{sdw},{sdw}

	adcf.b		{sdb}
	adcf.w		{sdw}

	add.b{g}	{imm8},{sdb}
	add.w{g}	{imm16},{sdw}
	add.b:q		{simm4},{sdb}
	add.w:q		{simm4},{sdw}
	add.b:s		{imm8},{dst3b}
	add.b:g		{sdb},{sdb}
	add.w:g		{sdw},{sdw}
	add.b:s		{r0l;{sb8};{fb8};{abs16}},r0h
	add.b:s		{r0h;{sb8};{fb8};{abs16}},r0l
	add.b{g}	{simm8},sp
	add.w{g}	{imm16},sp
	add.{b;w}:q	{simm4},sp

	adjnz.b		{simm4},{sdb},{label8}
	adjnz.w		{simm4},{sdw},{label8}

	and.b{g}	{imm8},{sdb}
	and.w{g}	{imm16},{sdw}
	and.b:s		{imm8},{dst3b}
	and.b{g}	{sdb},{sdb}
	and.w{g}	{sdw},{sdw}
	and.b:s		{r0l;{sb8};{fb8};{abs16}},r0h
	and.b:s		{r0h;{sb8};{fb8};{abs16}},r0l

	band		{bsrc}
	bclr:g		{bsrc}
	bclr:s		{bit3},{udsp8}[sb]
	bm{cond}	{c;{bsrc}}
	bnand		{bsrc}
	bnor		{bsrc}
	bnot:g		{bsrc}
	bnot:s		{bit3},{udsp8}[sb]
	bntst		{bsrc}
	bnxor		{bsrc}
	bor		{bsrc}

	brk

	bset:g		{bsrc}
	bset:s		{bit3},{udsp8}[sb]
	btst:g		{bsrc}
	btst:s		{bit3},{udsp8}[sb]
	btstc		{bsrc}
	btsts		{bsrc}
	bxor		{bsrc}

	cmp.b{g}	{imm8},{sdb}
	cmp.w{g}	{imm16},{sdw}
	cmp.b:q		{simm4},{sdb}
	cmp.w:q		{simm4},{sdw}
	cmp.b:s		{imm8},{dst3b}
	cmp.b{g}	{sdb},{sdb}
	cmp.w{g}	{sdw},{sdw}
	cmp.b:s		{r0l;{sb8};{fb8};{abs16}},r0h
	cmp.b:s		{r0h;{sb8};{fb8};{abs16}},r0l

	dad{c;d}.b	{r0h;{dimm8}},r0l
	dad{c;d}.w	{r1;{dimm16}},r0

	dec.b		{dst3b}
	dec.w		{a0;a1}

	div.b		{simm8}
	div.w		{simm16}
	div.b		{sdb}
	div.w		{sdw}

	divu.b		{uimm8}
	divu.w		{uimm16}
	divu.b		{sdb}
	divu.w		{sdw}

	divx.b		{simm8}
	divx.w		{simm16}
	divx.b		{sdb}
	divx.w		{sdw}

	d{sbb;sub}.b	{r0h;{dimm8}},r0l
	d{sbb;sub}.w	{r1;{dimm16}},r0

	enter		{uimm8}

	exitd

	exts.b		{r0l;r1l;{addrs}}
	exts.w		r0

	fclr		{c;d;z;s;b;o;i;u}
	fset		{c;d;z;s;b;o;i;u}

	inc.b		{dst3b}
	inc.w		{a0;a1}

	int		{uimm6}
	into

	j{cond}		{label8}

	jmp.s		{.+2;.+9;sym}
	jmp.b		{label8}
	jmp.w		{label16}
	jmp.a		{label20}

	jmpi.w		{labelw}
	jmpi.a		{labela}

	jsr.w		{label16}
	jsr.a		{label20}
	jsri.w		{labelw}
	jsri.a		{labela}

	ldc		{imm16},{cr}
	ldc		{sdw},{cr}

	ldctx		{abs16},{abs20}

	lde.b		{{abs20};{abs20}[a0];[a1a0]},{sdb}
	lde.w		{{abs20};{abs20}[a0];[a1a0]},{sdw}

	ldintb		#{abs20}

	ldipl		{uimm3}

	mov.b{g}	{imm8},{sdb}
	mov.w{g}	{imm16},{sdw}
	mov.b:q		{simm4},{sdb}
	mov.w:q		{simm4},{sdw}
	mov.b:s		{imm8},{dst3b}
	mov.b:s		{imm8},{a0;a1}
	mov.b:z		#0,{dst3b}
	mov.b{g}	{sdb},{sdb}
	mov.w{g}	{sdw},{sdw}
	mov.b:s		{dst2b},{a0;a1}
	mov.b:s		r0l,a1
	mov.b:s		r0h,a0
	mov.b:s		{r0l;r0h},{{sb8};{fb8};{abs16}}
	mov.b:s		{r0l;{sb8};{fb8};{abs16}},r0h
	mov.b:s		{r0h;{sb8};{fb8};{abs16}},r0l
	mov.b{g}	{sdsp8}[sp],{sdb}
	mov.w{g}	{sdsp8}[sp],{sdw}
	mov.b{g}	{sdb},{sdsp8}[sp]
	mov.w{g}	{sdw},{sdsp8}[sp]

	mova		{{{udsp8};{udsp16}}[a{0;1}];{sdsp8}[fb];{abs16}},{r0;r1;r2;r3;a0;a1}

	mov{ll;lh;hl;hh}	r0l,{r0h;r1l;r1h;{addrs}}
	mov{ll;lh;hl;hh}	{r0h;r1l;r1h;{addrs}},r0l

	mul.b		{simm8},{sdb}
	mul.w		{simm16},{sdw}
	mul.b		{sdb},{sdb}
	mul.w		{sdw},{sdw}

	mulu.b		{uimm8},{sdb}
	mulu.w		{uimm16},{sdw}
	mulu.b		{sdb},{sdb}
	mulu.w		{sdw},{sdw}

	neg.b		{sdb}
	neg.w		{sdw}

	nop

	not.b{g}	{sdb}
	not.w{g}	{sdw}
	not.b:s		{dst3b}

	or.b{g}	{imm8},{sdb}
	or.w{g}	{imm16},{sdw}
	or.b:s		{imm8},{dst3b}
	or.b		{sdb},{sdb}
	or.w		{sdw},{sdw}
	or.b:s		{r0l;{sb8};{fb8};{abs16}},r0h
	or.b:s		{r0h;{sb8};{fb8};{abs16}},r0l

	pop.b{g}	{sdb}
	pop.w{g}	{sdw}
	pop.b:s		{r0l;r0h}
	pop.w:s		{a0;a1}
	popc		{cr}
	popm		{;fb,}{;sb,}{;a1,}{;a0,}{;r3,}{;r2,}{;r1,}r0
	popm		{;fb,}sb

	push.b{g}	{imm8}
	push.w{g}	{imm16}
	push.b{g}	{sdb}
	push.w{g}	{sdw}
	push.b:s	{r0l;r0h}
	push.w:s	{a0;a1}
	pusha		{{{udsp8};{udsp16}}[a{0;1}];{sdsp8}[fb];{abs16}}
	pushc		{cr}
	pushm		{;fb,}{;sb,}{;a1,}{;a0,}{;r3,}{;r2,}{;r1,}r0
	pushm		{;fb,}sb

	reit

	rmpa.{b;w}

	rolc.b		{sdb}
	rolc.w		{sdw}
	rorc.b		{sdb}
	rorc.w		{sdw}

	rot.b		{nimm4},{sdb}
	rot.w		{nimm4},{sdw}
	rot.b		r1h,{sdb}
	rot.w		r1h,{sdw}

	rts

	sbb.b		{imm8},{sdb}
	sbb.w		{imm16},{sdw}
	sbb.b		{sdb},{sdb}
	sbb.w		{sdw},{sdw}

	sbjnz.b		{simm4n},{sdb},{label8}
	sbjnz.w		{simm4n},{sdw},{label8}

	sha.b		{nimm4},{sdb}
	sha.w		{nimm4},{sdw}
	sha.b		r1h,{sdb}
	sha.w		r1h,{sdw}
	sha.l		{nimm4},{r2r0;r3r1}
	sha.l		r1h,{r2r0;r3r1}

	shl.b		{nimm4},{sdb}
	shl.w		{nimm4},{sdw}
	shl.b		r1h,{sdb}
	shl.w		r1h,{sdw}
	shl.l		{nimm4},{r2r0;r3r1}
	shl.l		r1h,{r2r0;r3r1}

	smov{b;f}.{b;w}
	sstr.{b;w}

	stc		{cr},{sdw}
	stc		pc,{sdw}

	stctx		{abs16},{abs20}

	ste.b		{sdb},{{abs20};{abs20}[a0];[a1a0]}
	ste.w		{sdw},{{abs20};{abs20}[a0];[a1a0]}

	stnz		{imm8},{dst3b}
	stz		{imm8},{dst3b}
	stzx		{imm8},{imm8},{dst3b}

	sub.b{g}	{imm8},{sdb}
	sub.w{g}	{imm16},{sdw}
	sub.b:s		{imm8},{dst3b}
	sub.b:g		{sdb},{sdb}
	sub.w:g		{sdw},{sdw}
	sub.b:s		{r0l;{sb8};{fb8};{abs16}},r0h
	sub.b:s		{r0h;{sb8};{fb8};{abs16}},r0l

	tst.b		{imm8},{sdb}
	tst.w		{imm16},{sdw}
	tst.b		{sdb},{sdb}
	tst.w		{sdw},{sdw}

	und

	wait

	xchg.b		{r0l;r0h;r1l;r1h},{sdb}
	xchg.w		{r0;r1;r2;r3},{sdw}

	xor.b{g}	{imm8},{sdb}
	xor.w{g}	{imm16},{sdw}
	xor.b		{sdb},{sdb}
	xor.w		{sdw},{sdw}
